using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine.Events;
using TMPro;
using UnityEngine.SceneManagement;
using System.Linq;
using UnityEngine.UI;

namespace Mod
{
	public class Mod : MonoBehaviour
	{
		public static Map[] Maps;
		public static Map Vol;
		public static Sprite TemplateSprite = ModAPI.LoadSprite("logo.png");
		public static string mapname;
		public static MapSelectionMenuBehaviour mapmenu = UnityEngine.Object.FindObjectOfType<MapSelectionMenuBehaviour>();
		public static bool debounce = false;
		public static Sprite Square = ModAPI.LoadSprite("black.png");
		public static Sprite Lava = ModAPI.LoadSprite("Lava.png");
		public static Sprite Acid = ModAPI.LoadSprite("Acid.png");
		public static AudioClip acidhiss = ModAPI.LoadSound("Hiss.wav");
		public static bool Done = false;
		public static string MapModName = "SITE PARAGON";
		public static string MapName = "";
		public static Sprite CustomSprite2 = ModAPI.LoadSprite("map-sprites/CustomSprite2.png");
        public static Sprite CustomSprite3 = ModAPI.LoadSprite("map-sprites/CustomSprite3.png");
        public static Sprite CustomSprite5 = ModAPI.LoadSprite("map-sprites/CustomSprite5.png");
        public static Sprite CustomSprite6 = ModAPI.LoadSprite("map-sprites/CustomSprite6.png");
        public static Sprite CustomSprite7 = ModAPI.LoadSprite("map-sprites/CustomSprite7.png");
        public static Sprite CustomSprite8 = ModAPI.LoadSprite("map-sprites/CustomSprite8.png");
        public static Sprite CustomSprite9 = ModAPI.LoadSprite("map-sprites/CustomSprite9.png");
        public static Sprite CustomSprite10 = ModAPI.LoadSprite("map-sprites/CustomSprite10.png");
        public static Sprite CustomSprite12 = ModAPI.LoadSprite("map-sprites/CustomSprite12.png");
        public static Sprite CustomSprite14 = ModAPI.LoadSprite("map-sprites/CustomSprite14.png");
        public static Sprite CustomSprite17 = ModAPI.LoadSprite("map-sprites/CustomSprite17.png");
        public static Sprite CustomSprite18 = ModAPI.LoadSprite("map-sprites/CustomSprite18.png");
        public static Sprite CustomSprite19 = ModAPI.LoadSprite("map-sprites/CustomSprite19.png");
        public static Sprite CustomSprite20 = ModAPI.LoadSprite("map-sprites/CustomSprite20.png");
        public static Sprite CustomSprite21 = ModAPI.LoadSprite("map-sprites/CustomSprite21.png");
        public static Sprite CustomSprite22 = ModAPI.LoadSprite("map-sprites/CustomSprite22.png");
        public static Sprite CustomSprite23 = ModAPI.LoadSprite("map-sprites/CustomSprite23.png");
        public static Sprite CustomSprite24 = ModAPI.LoadSprite("map-sprites/CustomSprite24.png");
        public static Sprite CustomSprite4 = ModAPI.LoadSprite("map-sprites/CustomSprite4.png");
        public static Sprite CustomSprite26 = ModAPI.LoadSprite("map-sprites/CustomSprite26.png");
        public static Sprite CustomSprite27 = ModAPI.LoadSprite("map-sprites/CustomSprite27.png");
        public static Sprite CustomSprite28 = ModAPI.LoadSprite("map-sprites/CustomSprite28.png");
        public static Sprite CustomSprite29 = ModAPI.LoadSprite("map-sprites/CustomSprite29.png");
        public static Sprite CustomSprite16 = ModAPI.LoadSprite("map-sprites/CustomSprite16.png");
        public static Sprite CustomSprite11 = ModAPI.LoadSprite("map-sprites/CustomSprite11.png");
        public static Sprite CustomSprite30 = ModAPI.LoadSprite("map-sprites/CustomSprite30.png");
        public static Sprite CustomSprite31 = ModAPI.LoadSprite("map-sprites/CustomSprite31.png");
        public static Sprite CustomSprite15 = ModAPI.LoadSprite("map-sprites/CustomSprite15.png");
        public static Sprite CustomSprite13 = ModAPI.LoadSprite("map-sprites/CustomSprite13.png");
        public static Sprite CustomSprite32 = ModAPI.LoadSprite("map-sprites/CustomSprite32.png");
        public static Sprite CustomSprite33 = ModAPI.LoadSprite("map-sprites/CustomSprite33.png");
        public static Sprite CustomSprite34 = ModAPI.LoadSprite("map-sprites/ustomSprite34.png");
        public static Sprite CustomSprite35 = ModAPI.LoadSprite("map-sprites/CustomSprite35.png");
        public static Sprite CustomSprite37 = ModAPI.LoadSprite("map-sprites/CustomSprite37.png");
        public static Sprite CustomSprite38 = ModAPI.LoadSprite("map-sprites/CustomSprite38.png");
        public static Sprite CustomSprite39 = ModAPI.LoadSprite("map-sprites/CustomSprite39.png");
        public static Sprite CustomSprite40 = ModAPI.LoadSprite("map-sprites/CustomSprite40.png");
        public static Sprite CustomSprite41 = ModAPI.LoadSprite("map-sprites/CustomSprite41.png");
        public static Sprite CustomSprite42 = ModAPI.LoadSprite("map-sprites/CustomSprite42.png");
        

		public static PhysicalProperties phys = ModAPI.FindPhysicalProperties("Soft");

		public static void OnLoad()
		{
			phys.Brittleness = 0f;
			phys.Buoyancy = 0f;
			phys.Flammability = 0f;
			phys.MagneticAttractionIntensity = 0f;
			phys.Conducting = false;
			phys.Burnrate = 0f;
			phys.ImpactIntensityMutliplier = 1f;
			phys.HitVolumeMultiplier = 1f;
			phys.BulletSpeedAbsorptionPower = 0f;
			phys.Softness = 0.1f;
			phys.LodgeStrengthMultiplier = 0.1f;
			phys.SharpForceThresholdMultiplier = 1f;
			// 
			Map MapMod = ScriptableObject.CreateInstance<Map>();
			MapMod.name = MapName;
			MapMod.UniqueIdentity = Guid.NewGuid().ToString();
			MapMod.Description = "Map";
			MapMod.Thumbnail = ModAPI.LoadSprite("logo.png");
			MapMod.Preview = ModAPI.LoadSprite("logo.png");
			MapMod.Prefab = MapRegistry.GetAllMaps().ElementAt(2).Prefab;
			MapModName = MapMod.name;
			MapRegistry.Register(MapMod);
		}

		public static void RemoveBorders()
		{
			foreach (var render in GameObject.Find("Root").transform.parent.GetComponentsInChildren<SpriteRenderer>())
			{
				if (render.gameObject.layer == LayerMask.NameToLayer("Bounds") && render.gameObject.GetComponent<Undraggable>())
				{
					Destroy(render.gameObject);
				}
			}

			Map eggs = Resources.Load<Map>("Maps/Humongous");
			foreach (MapLightBehaviour light in UnityEngine.Object.FindObjectsOfType<MapLightBehaviour>())
			{
				Destroy(light.gameObject);
			}
			var thing = Instantiate<GameObject>(eggs.Prefab.transform.Find("Lightbulb/BulbGlow/full ambient").gameObject);
			thing.transform.position = new Vector2(500f, 100f);
			thing.transform.localScale = new Vector2(100000f, 100000f);
			thing.GetComponent<SpriteRenderer>().material.SetFloat("_GlowIntensity", 1.2f);
			thing.GetComponent<SpriteRenderer>().material.SetColor("_GlowColour", new Color32(255, 255, 255, 225));
			if (GameObject.Find("Panels"))
			{
				GameObject.Find("Panels").transform.localScale = new Vector2(100000f, 100000f);
			}
			MapConfig mapconfig = UnityEngine.Object.FindObjectOfType<MapConfig>();
			mapconfig.GetComponent<BoundingBoxBehaviour>().BoundingBox = new Bounds(new Vector3(500f, 250f, 0f), new Vector3(1500000f, 1500000f, 0f));
		}

		public static void CreateGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, string Layer, bool NoCollision, int Order = 0)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, Mod.Square);
			NewGameobject.tag = "NoClear";
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.position = Pos;
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Top");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			NewGameobject.transform.rotation = Rotation;
			if (NoCollision)
			{
				NewGameobject.GetComponent<Collider2D>().enabled = false;
			}
			NewGameobject.transform.parent = null;
			NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = Order;
			NewGameobject.AddComponent<Undraggable>();
			NewGameobject.GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeAll;
			NewGameobject.AddComponent<ContextMenuOptionComponent>();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			physicalBehaviour.Properties = Mod.phys;
			physicalBehaviour.SpawnSpawnParticles = false;
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
			physicalBehaviour.Deletable = false;
			physicalBehaviour.Disintegratable = false;
			///NewGameobject.AddComponent<AudioSource>();
			///NewGameobject.AddComponent<AudioSourceTimeScaleBehaviour>();
			NewGameobject.AddComponent<TestDelay>();
		}

		public static void CreateCustomGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Sprite spritey, string Layer, bool NoCollision, int Order = 0)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, spritey);
			NewGameobject.tag = "NoClear";
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			NewGameobject.FixColliders();
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Top");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			if (NoCollision)
			{
				foreach (var col in NewGameobject.GetComponents<Collider2D>())
				{
					col.enabled = false;
				}
			}
			NewGameobject.transform.parent = null;
			NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = Order;
			NewGameobject.GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeAll;
			NewGameobject.AddComponent<Undraggable>();
			NewGameobject.AddComponent<ContextMenuOptionComponent>();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			physicalBehaviour.Properties = Mod.phys;
			physicalBehaviour.SpawnSpawnParticles = false;
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
			physicalBehaviour.Deletable = false;
			physicalBehaviour.Disintegratable = false;
			physicalBehaviour.rigidbody = NewGameobject.GetComponent<Rigidbody2D>();
			///NewGameobject.AddComponent<AudioSource>();
			///NewGameobject.AddComponent<AudioSourceTimeScaleBehaviour>();
			NewGameobject.AddComponent<TestDelay>();
		}

		public static void CreateSpawnable(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, bool FacingRight, bool Frozen)
		{
			GameObject NewGameobject = Instantiate<GameObject>(ModAPI.FindSpawnable(Name).Prefab, Vector3.zero, Quaternion.identity);
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			if (!FacingRight)
			{
				NewGameobject.transform.localScale = new Vector2(-NewGameobject.transform.localScale.x, NewGameobject.transform.localScale.y);
			}
			if (Frozen)
			{
				NewGameobject.AddComponent<TestDelay>();
			}
		}

		public static void CreatePhysicsGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Sprite spritey, string Layer, bool NoCollision)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, spritey);
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Objects");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			NewGameobject.FixColliders();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			if (NoCollision)
			{
				NewGameobject.GetComponent<Collider2D>().enabled = false;
			}
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
		}

		public static void CreateLightSources(String Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Color32 color, float brightness)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			var light = ModAPI.CreateLight(NewGameobject.transform, color, brightness);
			light.gameObject.tag = "NoClear";
		}

		public static void CreateBackground(String Name, Color32 color, Sprite spritey, bool IsTexture)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = new Vector2(572.314f, 496.2918f);
			var whitespace = Texture2D.whiteTexture;
			whitespace.Resize(16, 16);
			whitespace.Apply();
			if (IsTexture == true)
			{
				var croppedTexture = new Texture2D((int)spritey.rect.width, (int)spritey.rect.height);
				var pixels = spritey.texture.GetPixels((int)spritey.textureRect.x,
														(int)spritey.textureRect.y,
														(int)spritey.textureRect.width,
														(int)spritey.textureRect.height);
				croppedTexture.SetPixels(pixels);
				croppedTexture.wrapMode = TextureWrapMode.Repeat;
				croppedTexture.filterMode = FilterMode.Point;
				croppedTexture.Apply();
				var copy = Sprite.Create(croppedTexture, new Rect(0f, 0f, (float)croppedTexture.width, (float)croppedTexture.height), 0.5f * Vector2.one, 140f, 0, SpriteMeshType.FullRect);
				NewGameobject.AddComponent<SpriteRenderer>().drawMode = SpriteDrawMode.Tiled;
				NewGameobject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");
				NewGameobject.GetComponent<SpriteRenderer>().sprite = copy;
				NewGameobject.GetComponent<SpriteRenderer>().size = new Vector2(5, 5);
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Bottom");
				///NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = 25;
			}
			else
			{
				NewGameobject.AddComponent<SpriteRenderer>().sprite = Sprite.Create(whitespace, new Rect(0f, 0f, 16f, 16f), 0.5f * Vector2.one, 35f);
				NewGameobject.GetComponent<SpriteRenderer>().color = color;
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Bottom");
				///NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = 25;
			}
			NewGameobject.transform.localScale = new Vector2(2533.112f, 2175.462f);
			NewGameobject.transform.parent = null;
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
		}

		public static void CreateParticleSources(string Name, Vector2 Pos, float Speed, string Particles)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.name = Name;
			NewGameobject.transform.position = Pos;
			NewGameobject.AddComponent<ParticleDelay>();
			NewGameobject.GetComponent<ParticleDelay>().Speed1 = Speed;
			NewGameobject.GetComponent<ParticleDelay>().Particles1 = Particles;
		}

		public static void AddAudioToAmbience(float Bacon, AudioClip[] Eggs)
		{
			///Changing this to other variables in the MapConfig will let you force snow on and other stuff.
			MapConfig mapconfig = UnityEngine.Object.FindObjectOfType<MapConfig>();
			///mapconfig.OverrideAmbientSounds = true;
			var hhh = mapconfig.transform.parent.GetComponent<PlayAudioAtRandom>();
			hhh.Clips = Eggs;
			hhh.ChancePerSecond = Bacon;
		}

		public static void CreateWaterBlock(Vector3 Size, Vector3 Pos, Quaternion Rotation, string Type)
		{
			switch (Type)
			{
				case "Water":
					{
						Map sea = Resources.Load<Map>("Maps/Sea");
						GameObject WaterBefore = sea.Prefab.transform.Find("Root/Sea").gameObject;
						var Water = Instantiate<GameObject>(WaterBefore, Vector3.zero, Quaternion.identity);
						Water.transform.rotation = Rotation;
						Water.transform.localScale = new Vector2(Size.x, -Size.y);
						Water.transform.localPosition = Pos;
						break;
					}
				case "Acid":
					{
						Map sea = Resources.Load<Map>("Maps/Sea");
						GameObject WaterBefore = sea.Prefab.transform.Find("Root/Sea").gameObject;
						var Water = Instantiate<GameObject>(WaterBefore, Vector3.zero, Quaternion.identity);
						Water.transform.rotation = Rotation;
						Water.transform.localScale = new Vector2(Size.x, -Size.y);
						Water.transform.localPosition = Pos;
						Water.name = "Acid";
						Water.AddComponent<AcidWater>();
						break;
					}
				case "Lava":
					{
						Map lavaMap = Resources.Load<Map>("Maps/Lava");
						GameObject LavaBefore = lavaMap.Prefab.transform.Find("Lava pool").gameObject;
						var Lava = Instantiate<GameObject>(LavaBefore, Vector3.zero, Quaternion.identity);
						Lava.transform.rotation = Rotation;
						Lava.transform.localScale = new Vector2(Size.x, -Size.y);
						Lava.transform.localPosition = Pos;
						break;
					}
			}
		}

		public static void Main()
        {
			if (MapLoaderBehaviour.CurrentMap.name == MapModName)
			{
				Debug.Log("Setting up some stuff.");
				var manager = new GameObject("managerMap");
				manager.AddComponent<MapModManager>();
			}

            CategoryBuilder.Create("SITE PARAGON", "Big underground facility.", ModAPI.LoadSprite("category.png"));

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Employee",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "*keyboard tapping sounds* Office clerk, comes with 5 skin variations.s",
                    CategoryOverride = ModAPI.FindCategory("SITE PARAGON"),
                    ThumbnailOverride = ModAPI.LoadSprite("employee-thumb.png"),
                    AfterSpawn = (Instance) =>
                        {
                            // var skin = ModAPI.LoadTexture("human-sprites/employee1.png");
                            // var flesh = ModAPI.LoadTexture("human-sprites/base/flesh.png");
                            // var bone = ModAPI.LoadTexture("human-sprites/base/bone.png");
                            // Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                            var person = Instance.GetComponent<PersonBehaviour>();

                            // person.SetBodyTextures(skin, flesh, bone, 1);

							foreach (var limb in person.Limbs)
                        	{
								var HumanSprites = limb.gameObject.GetOrAddComponent<RandomHumanTextureBehaviour>();
                            	HumanSprites.person = person;
								HumanSprites.Textures.Add(ModAPI.LoadTexture("human-sprites/employee1.png")); 
								HumanSprites.Textures.Add(ModAPI.LoadTexture("human-sprites/employee2.png")); 
                            	HumanSprites.Textures.Add(ModAPI.LoadTexture("human-sprites/employee3.png")); 
                            	HumanSprites.Textures.Add(ModAPI.LoadTexture("human-sprites/employee4.png")); 
                                HumanSprites.Textures.Add(ModAPI.LoadTexture("human-sprites/employee5.png"));
							}

                            person.SetBruiseColor(145, 30, 30);
                            person.SetSecondBruiseColor(60, 0, 0);
                            person.SetThirdBruiseColor(30, 0, 0);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);
                        }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Security guard",
                    NameToOrderByOverride = "2",
                    DescriptionOverride = "Tough guy to keep the violent and agressive persons.",
                    CategoryOverride = ModAPI.FindCategory("SITE PARAGON"),
                    ThumbnailOverride = ModAPI.LoadSprite("security-thumb.png"),
                    AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("human-sprites/security.png");
                            var flesh = ModAPI.LoadTexture("human-sprites/base/flesh.png");
                            var bone = ModAPI.LoadTexture("human-sprites/base/bone.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(skin, flesh, bone, 1);

                            person.SetBruiseColor(145, 30, 30);
                            person.SetSecondBruiseColor(60, 0, 0);
                            person.SetThirdBruiseColor(30, 0, 0);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);

                            foreach (var body in person.Limbs)
                            {
                                body.Health *= 1.5f;
                                body.InitialHealth *= 1.5f;
                            }

                        }
                }
            );

			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Logistics unit",
                    NameToOrderByOverride = "3",
                    DescriptionOverride = "Provides stability to the work of the Site.",
                    CategoryOverride = ModAPI.FindCategory("SITE PARAGON"),
                    ThumbnailOverride = ModAPI.LoadSprite("logistics-thumb.png"),
                    AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("human-sprites/logistics.png");
                            var flesh = ModAPI.LoadTexture("human-sprites/base/flesh.png");
                            var bone = ModAPI.LoadTexture("human-sprites/base/bone.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(skin, flesh, bone, 1);

                            person.SetBruiseColor(145, 30, 30);
                            person.SetSecondBruiseColor(60, 0, 0);
                            person.SetThirdBruiseColor(30, 0, 0);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);
                        }
                }
            );

			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Janitor",
                    NameToOrderByOverride = "4",
                    DescriptionOverride = "Does cleanup.",
                    CategoryOverride = ModAPI.FindCategory("SITE PARAGON"),
                    ThumbnailOverride = ModAPI.LoadSprite("janitor-thumb.png"),
                    AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("human-sprites/janitor.png");
                            var flesh = ModAPI.LoadTexture("human-sprites/base/flesh.png");
                            var bone = ModAPI.LoadTexture("human-sprites/base/bone.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(skin, flesh, bone, 1);

                            person.SetBruiseColor(145, 30, 30);
                            person.SetSecondBruiseColor(60, 0, 0);
                            person.SetThirdBruiseColor(30, 0, 0);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);
                        }
                }
            );

			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Site administrator",
                    NameToOrderByOverride = "5",
                    DescriptionOverride = "A person responsible for the performance and management of administrative operations.",
                    CategoryOverride = ModAPI.FindCategory("SITE PARAGON"),
                    ThumbnailOverride = ModAPI.LoadSprite("admin-thumb.png"),
                    AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("human-sprites/administrator.png");
                            var flesh = ModAPI.LoadTexture("human-sprites/base/flesh.png");
                            var bone = ModAPI.LoadTexture("human-sprites/base/bone.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                            var person = Instance.GetComponent<PersonBehaviour>();

                            person.SetBodyTextures(skin, flesh, bone, 1);

                            person.SetBruiseColor(145, 30, 30);
                            person.SetSecondBruiseColor(60, 0, 0);
                            person.SetThirdBruiseColor(30, 0, 0);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);

							foreach (var body in person.Limbs)
                            {
                                body.Health *= 1.2f;
                                body.InitialHealth *= 1.2f;
                            }
                        }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Blitz",
                    NameToOrderByOverride = "6",
                    DescriptionOverride = "Some sort of radical extremist organized crime group. Comes with 3 skin variations.\nFOR THE MOTHERLAND!",
                    CategoryOverride = ModAPI.FindCategory("SITE PARAGON"),
                    ThumbnailOverride = ModAPI.LoadSprite("raider-thumb.png"),
                    AfterSpawn = (Instance) =>
                        {
                            var person = Instance.GetComponent<PersonBehaviour>();

							foreach (var limb in person.Limbs)
                        	{
								var HumanSprites = limb.gameObject.GetOrAddComponent<RandomHumanTextureBehaviour>();
                            	HumanSprites.person = person;
								HumanSprites.Textures.Add(ModAPI.LoadTexture("human-sprites/raider1.png")); 
								HumanSprites.Textures.Add(ModAPI.LoadTexture("human-sprites/raider2.png")); 
                            	HumanSprites.Textures.Add(ModAPI.LoadTexture("human-sprites/raider3.png")); 
							}

                            person.SetBruiseColor(145, 30, 30);
                            person.SetSecondBruiseColor(60, 0, 0);
                            person.SetThirdBruiseColor(30, 0, 0);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);

                            foreach (var body in person.Limbs)
                            {
                                body.Health *= 4f;
                                body.InitialHealth *= 4f;
                            }
                        }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "SRRU Unit",
                    NameToOrderByOverride = "7",
                    DescriptionOverride = "SRRU - Special Rapid Response Team, serves primarily as the main battle unit of the Site Paragon. Comes with 2 skin variations.",
                    CategoryOverride = ModAPI.FindCategory("SITE PARAGON"),
                    ThumbnailOverride = ModAPI.LoadSprite("srru-thumb.png"),
                    AfterSpawn = (Instance) =>
                        {
                            var person = Instance.GetComponent<PersonBehaviour>();

							foreach (var limb in person.Limbs)
                        	{
								var HumanSprites = limb.gameObject.GetOrAddComponent<RandomHumanTextureBehaviour>();
                            	HumanSprites.person = person;
								HumanSprites.Textures.Add(ModAPI.LoadTexture("human-sprites/srru1.png")); 
								HumanSprites.Textures.Add(ModAPI.LoadTexture("human-sprites/srru2.png")); 

                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                                backpack.transform.localPosition = new Vector3(0, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("human-sprites/srru-backpack.png");
							}

                            person.SetBruiseColor(145, 30, 30);
                            person.SetSecondBruiseColor(60, 0, 0);
                            person.SetThirdBruiseColor(30, 0, 0);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);

                            foreach (var body in person.Limbs)
                            {
                                body.Health *= 2f;
                                body.InitialHealth *= 2f;
                            }
                        }
                }
            );
        }

		public static void InitilizeMap()
		{
			foreach (var waterBlock in GameObject.FindObjectsOfType<WaterBehaviour>())
			{
				GameObject.Destroy(waterBlock.gameObject);
			}
			foreach (var waterBlock in GameObject.FindObjectsOfType<LavaBehaviour>())
			{
				GameObject.Destroy(waterBlock.gameObject);
			}
			
			CreateGameObjects("Other", new Vector2(42.18611f, 6.119897f), new Vector2(3513f, 42f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(-0.6228261f, 1.159804f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(0.5647218f, 1.237172f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(0.5650332f, 4.061138f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(7.983759f, 1.237719f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite5, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(1.677779f, 1.245431f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(81.25022f, 7.957697f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(-3.411512f, 1.3918f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(85.43798f, 2.795828f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite9, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(24.73226f, 7.687845f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(89.01859f, 21.51803f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite12, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(84.08114f, 7.688277f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(92.70851f, 22.20025f), new Vector2(42f, -1558f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(0.5452282f, 7.957447f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(0.5516537f, 10.77188f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(42.69979f, 12.71119f), new Vector2(3513f, 42f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(42.37433f, 19.4775f), new Vector2(3513f, 42f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(0.5657215f, 17.36484f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(0.5618213f, 14.54954f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(0.5702028f, 21.34093f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(42.88345f, 26.21941f), new Vector2(3513f, 42f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(0.5701804f, 24.16015f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(42.39227f, 32.97078f), new Vector2(3513f, 42f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(0.5757349f, 28.0633f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(0.5728134f, 30.87726f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(-3.428911f, 8.104353f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(-3.383947f, 14.69575f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(-3.347202f, 21.46682f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(-3.32864f, 28.20153f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(-0.641744f, 7.966722f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(-0.6829127f, 14.55317f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(-0.7304056f, 21.31593f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(-0.7663149f, 28.06903f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(78.02453f, 1.25048f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(78.02142f, 4.074203f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(62.76981f, 1.177194f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(62.78679f, 4.005648f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(75.63547f, 1.318778f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(73.04508f, 1.238309f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(73.04608f, 4.056034f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(48.12284f, 1.2449f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(35.60098f, 1.232711f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(55.67877f, 1.217484f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(51.85079f, 1.232239f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(44.80607f, 1.230569f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(44.81199f, 4.04895f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(27.94224f, 7.191529f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(59.52869f, 0.4564024f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(39.88048f, 0.4813336f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(26.01307f, 7.577044f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite18, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(29.91525f, 7.57807f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite19, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(61.28054f, 0.8475336f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite19, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(57.8208f, 0.861004f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite18, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(37.95907f, 0.8609568f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite18, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(41.7471f, 0.8600389f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite19, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(23.79765f, 7.81105f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite20, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(53.79012f, 1.094417f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite20, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(67.6729f, 1.000709f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite21, "Front", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(67.67242f, 2.821137f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite21, "Front", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(67.67201f, 4.605402f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite21, "Front", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(82.14929f, 4.735701f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite22, "Front", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(91.78783f, 0.3353034f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 89.60001f), CustomSprite23, "Front", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(80.95338f, 1.58501f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite24, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(33.32082f, 1.229331f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(33.32146f, 4.043828f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(26.6803f, 0.4525703f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(28.41582f, 0.8623052f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite19, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(24.9217f, 0.864707f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite18, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(30.70051f, 1.093588f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite20, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(22.71613f, 1.218849f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(21.13702f, 1.224533f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(4.461791f, 1.236223f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(82.54405f, 7.960742f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(82.54076f, 10.77897f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(91.0181f, 7.96311f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(88.80097f, 7.96311f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(86.59103f, 7.970137f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(33.33303f, 7.958136f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(33.34515f, 10.76857f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(88.7848f, 17.37959f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(88.7859f, 14.56532f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(91.61941f, 14.13387f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite26, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(89.97208f, 14.01902f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite27, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(89.11138f, 18.642f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 269.7f), CustomSprite28, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(79.3028f, 14.55252f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(79.31023f, 17.36527f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(81.83224f, 14.90877f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite29, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(84.12192f, 14.91877f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite29, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(36.87262f, 7.688673f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(39.69969f, 7.689238f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(42.61093f, 7.692875f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(45.24104f, 7.684789f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(46.40446f, 7.691453f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(48.7617f, 7.58659f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite16, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(52.17556f, 7.190022f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite11, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(50.86502f, 7.488498f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite30, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(53.51517f, 7.503681f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite31, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(55.69804f, 7.691443f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(58.96108f, 7.562164f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite16, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(62.1189f, 7.666399f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(64.07887f, 7.694242f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(65.57343f, 7.809614f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite20, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(77.53357f, 7.966151f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite5, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(68.64371f, 7.962825f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite5, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(70.37378f, 7.965265f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(72.49905f, 7.59259f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite15, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(75.2059f, 7.173971f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite11, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(76.50146f, 7.499539f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite31, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(79.37744f, 7.590846f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(66.21975f, 7.499828f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite30, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(34.49696f, 7.818672f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite20, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(12.91717f, 7.963496f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite5, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(10.59674f, 7.956478f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite5, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(21.24902f, 7.956699f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(16.49213f, 10.7834f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(16.4969f, 7.96709f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(65.30667f, 14.55907f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(65.30042f, 17.37706f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(60.44625f, 9.324376f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite32, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(90.76039f, 3.798563f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite33, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(67.26846f, 14.59585f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite34, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(69.54594f, 13.78584f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(72.15003f, 13.78561f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(69.06213f, 14.47236f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite35, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(76.10899f, 14.55566f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite5, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(74.9551f, 14.40953f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite20, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(68.17557f, 14.02844f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite37, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(39.17155f, 17.3614f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(39.16954f, 14.55027f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(16.49981f, 17.35907f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(16.50569f, 14.54992f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(6.995902f, 14.55649f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite5, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(4.888453f, 14.55059f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(11.57478f, 13.79411f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(8.456685f, 14.40818f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite20, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(7.871284f, 7.683636f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(7.028966f, 7.684119f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(3.733117f, 7.669831f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(5.35118f, 7.180677f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite11, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(2.068032f, 7.590527f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(21.28396f, 13.78441f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(31.95403f, 13.7823f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(33.87201f, 14.16709f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite19, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(23.22305f, 14.1641f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite19, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(19.20917f, 14.17094f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite18, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(29.89255f, 14.16899f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite18, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(26.39968f, 14.55922f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(28.63944f, 14.38744f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite20, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(36.83618f, 14.55843f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(42.95243f, 14.28161f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(49.42907f, 14.28161f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(56.7398f, 14.28161f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(46.05357f, 14.18511f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite16, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(53.01714f, 14.2769f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(53.86632f, 14.27444f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(41.07127f, 14.28228f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(62.35229f, 14.41265f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite20, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(60.01624f, 14.56804f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite5, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(74.78356f, 24.14308f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(74.77821f, 21.3247f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(87.74379f, 21.51773f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite12, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(86.43249f, 21.51707f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite12, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(82.63438f, 21.52209f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite12, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(81.32202f, 21.52211f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite12, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(80.01211f, 21.51944f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite12, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(84.48045f, 21.3268f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(77.74567f, 20.94545f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(71.29915f, 21.04908f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(67.13633f, 21.0258f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(62.91415f, 21.04908f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(50.40404f, 20.90117f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite16, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(46.43962f, 20.93965f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite16, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(37.02945f, 21.03955f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(33.67946f, 21.04796f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(30.34272f, 21.04796f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(65.0713f, 21.04214f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(69.23904f, 21.03341f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(48.33514f, 21.03527f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(39.0141f, 21.03795f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(28.25129f, 21.03795f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(41.215f, 20.53404f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite11, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(56.64047f, 20.54808f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite11, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(55.21434f, 20.8661f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite30, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(58.04205f, 20.86375f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite31, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(60.26178f, 21.17641f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite20, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(43.93223f, 21.17173f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite20, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(79.4288f, 24.84045f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite22, "Front", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(53.05743f, 21.33009f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite5, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(9.359843f, 21.32174f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(10.98305f, 21.32134f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite5, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(7.616101f, 21.32626f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite5, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(22.01387f, 20.55671f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(23.86197f, 20.93364f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite19, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(20.21757f, 20.93591f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite18, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(17.01839f, 20.55246f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(18.81785f, 20.92767f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite19, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(15.21139f, 20.93285f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite18, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(26.13774f, 21.32468f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(26.15019f, 24.15473f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(83.42673f, 30.87974f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(83.42363f, 28.06687f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(85.86661f, 27.39543f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite38, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(89.85484f, 27.4001f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite38, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(58.52568f, 28.06872f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(58.52265f, 30.87888f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(62.27668f, 27.85938f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite39, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(66.57774f, 27.84141f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite39, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(70.00478f, 27.69027f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite15, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(72.35687f, 28.06907f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(76.35234f, 28.06812f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(76.3563f, 30.87996f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(78.30043f, 27.69079f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite40, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(79.91729f, 27.20418f), new Vector2(-0.8300003f, -0.4400011f), Quaternion.Euler(0f, 0f, 0f), CustomSprite40, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(79.5544f, 27.92501f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite41, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(80.09408f, 27.92501f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite41, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(46.45705f, 27.70151f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite40, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(48.24863f, 27.70151f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite40, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(49.89118f, 27.21525f), new Vector2(-0.8300003f, -0.4400011f), Quaternion.Euler(0f, 0f, 0f), CustomSprite40, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(45.07155f, 27.20966f), new Vector2(-0.4600007f, -0.4400011f), Quaternion.Euler(0f, 0f, 0f), CustomSprite40, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(45.05076f, 27.92905f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite41, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(53.02383f, 28.06447f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite5, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(34.0611f, 27.29076f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite11, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(36.62301f, 27.28977f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite11, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(34.09608f, 27.87581f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite42, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(36.09724f, 27.15385f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite41, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(36.67188f, 27.1533f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite41, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(38.09651f, 27.59649f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite31, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(41.0621f, 28.06217f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(41.0607f, 30.88243f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(26.16686f, 28.06188f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(26.16713f, 30.87667f), new Vector2(7f, 110f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(29.79317f, 27.70861f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite40, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(19.98607f, 28.07135f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite5, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(16.03247f, 28.06075f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite5, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(9.285761f, 28.07937f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(12.5801f, 27.29123f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(13.96773f, 27.91727f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite20, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(14.20284f, 0.4615201f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(12.19061f, 0.8532739f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite18, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(16.30354f, 0.8525406f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite19, "Back", true, 0);
                CreateGameObjects("Other", new Vector2(778.2205f, 500.2788f), new Vector2(47946.92f, -37758f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(199.7221f, 572.7692f), new Vector2(47946.92f, -37758f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                
		}
	}
	public class AcidWater : MonoBehaviour
	{
		private void Start()
		{
			SpriteRenderer spriteRenderer = gameObject.GetComponent<SpriteRenderer>();
			spriteRenderer.material.shader = Shader.Find("Sprites/Default");
			spriteRenderer.material.color = new Color(0, 1f, 0.1509f, 0.1819f);
			spriteRenderer.color = new Color(0, 1, 0, 1);
		}
		private void OnTriggerEnter2D(Collider2D collider2D)
		{
			if (collider2D.gameObject.GetComponent<LimbBehaviour>() != null)
			{
				collider2D.gameObject.AddComponent<AcidEffect>();
			}
		}
		private void OnTriggerExit2D(Collider2D collider2D)
		{
			if (collider2D.gameObject.GetComponent<AcidEffect>() != null)
			{
				UnityEngine.Object.Destroy(collider2D.gameObject.GetComponent<AcidEffect>());
			}
		}

	}
	public class AcidEffect : MonoBehaviour
	{
		LimbBehaviour limbBehaviour;
		private void Start()
		{
			limbBehaviour = gameObject.GetComponent<LimbBehaviour>();
		}
		private void Update()
		{
			limbBehaviour.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("ACID"), 0.05f * Time.deltaTime);
		}
	}
	public class MapModManager : MonoBehaviour
	{
		private void Start()
		{
			Mod.InitilizeMap();
		}
	}

	public class TestDelay : MonoBehaviour
	{
		public void Awake()
		{
			StartCoroutine(Delay());
		}

		public IEnumerator Delay()
		{
			yield return new WaitForSeconds(0f);
			foreach (var Rig in this.gameObject.GetComponentsInChildren<Rigidbody2D>())
			{
				Rig.bodyType = RigidbodyType2D.Static;
			}
		}
	}

	public class ParticleDelay : MonoBehaviour
	{
		public string Particles1;
		public float Speed1;
		public void Awake()
		{
			StartCoroutine(Emit());
		}

		public IEnumerator Emit()
		{
			yield return new WaitForSeconds(0.25f);
			while (true)
			{
				var time = 1f / Speed1;
				ModAPI.CreateParticleEffect(Particles1.ToString(), gameObject.transform.position);
				yield return new WaitForSeconds(time);
			}
		}
	}

	public class RandomHumanTextureBehaviour : MonoBehaviour
    {
        private void Start()
        {
            this.phys = gameObject.GetComponent<PhysicalBehaviour>();
            chosenIndex = UnityEngine.Random.Range(0, Textures.Count - 0); 
            NextTexture();   
            phys.ContextMenuOptions.Buttons.Add(menuButton = new ContextMenuButton("NextTexture", "Next skin", "Switches to the next skin", new UnityAction[1]
            {
                (UnityAction) (() =>
                {
                    NextTexture();
                    foreach (var limb in person.Limbs)
                    {
                        if (limb.GetComponent<RandomHumanTextureBehaviour>())
                        {
                            limb.GetComponent<RandomHumanTextureBehaviour>().chosenIndex = chosenIndex;
                        }
                    }
                })
            }));     
            phys.ContextMenuOptions.Buttons.Add(menuButton = new ContextMenuButton("PreviousTexture", "Previous skin", "Switches to the previous skin", new UnityAction[1]
            {
                (UnityAction) (() =>
                {
                    PreviousTexture();
                    foreach (var limb in person.Limbs)
                    {
                        if (limb.GetComponent<RandomHumanTextureBehaviour>())
                        {
                            limb.GetComponent<RandomHumanTextureBehaviour>().chosenIndex = chosenIndex;
                        }
                    }
                })
            }));
        }
        private void NextTexture()
        {
            chosenIndex += 1;
            if (chosenIndex > Textures.Count - 1)
            {
                chosenIndex = 0;
            }
            person.SetBodyTextures(Textures[chosenIndex]);
        }
        private void PreviousTexture()
        {
            chosenIndex -= 1;
            if (chosenIndex < 0)
            {
                chosenIndex = Textures.Count - 1;
            }
            person.SetBodyTextures(Textures[chosenIndex]);
        }

       public List<Texture2D> Textures = new List<Texture2D>();
       public int chosenIndex = -1;
       public PersonBehaviour person;
       private PhysicalBehaviour phys;
       private ContextMenuButton menuButton;
	}
}


// Originally uploaded by 'eclipsexxddd'. Do not reupload without their explicit permission.
